# Menu Loader created by Didier Bur - tweaked without permission by Max Coppoletta ;)



# First check to see if we have already loaded this file so that we only add the item to the menu once
    if( not file_loaded?("menus.rb") )


    # displays menus only once, even after more than one load
    if( not $menus_loaded )
  
    # This will add a separator to the menu, but only once
    add_separator_to_menu("Plugins")
    
    
    
    # Creates a sub-menu item Archi under the Plugins menu
    _archi_plugins_menu = UI.menu("Plugins").add_submenu("Archi") 

    # Creates a sub-menu item Edit under the Plugins menu
    _edit_plugins_menu = UI.menu("Plugins").add_submenu("Edit")
    
     # Creates a sub-menu item View under the Plugins menu
    _view_plugins_menu = UI.menu("Plugins").add_submenu("View")
    
    # Creates a sub-menu item Modify under the Plugins menu
    _modify_plugins_menu = UI.menu("Plugins").add_submenu("Modify")    
    
    # Creates a sub-menu item Camera under the Plugins menu
    _camera_plugins_menu = UI.menu("Plugins").add_submenu("Camera")
    
    # Creates a sub-menu item Draw under the Plugins menu
    _draw_plugins_menu = UI.menu("Plugins").add_submenu("Draw")
    
    # Creates a sub-menu item Text under the Plugins menu
    _text_plugins_menu = UI.menu("Plugins").add_submenu("Text")       
    
    # Creates a sub-menu item Tools under the Plugins menu
    _tools_plugins_menu = UI.menu("Plugins").add_submenu("Tools")
    
    # Creates a sub-menu item Windows under the Plugins menu
    _windows_plugins_menu = UI.menu("Plugins").add_submenu("Windows")
    
    
    
##########################################################################################################
#
#
#
#    LIST OF SCRIPTS LOADED BY THIS MENU
#	
#	- ATTRIBUTES (@Last)
#	- BEZIER 1.0 (@Last)
#	- BOMB 1.0 (Rick Wilson)
#	- BOX 1.0 (@Last)
#	- BOX_POS 1.0 (@Last)
#	- CABINET 1.0 (Todd Burch)
#	- CAMERA PARAMETERS 1.0 (Envision 3D)
#	- CLEANUP_PUSHPULL 1.0 (Carlo)
#	- 3D GRID 1.0 (Jim Patrick/Didier Bur)
#	- CURVE STITCHER 2.0 (Rick Wilson)
#	- DESEL 1.0 (TBD)
#	- DROP 1.5 (TBD)
#	- EXAMPLES (@Last)
#	- EXTEND 1.0 (Rick Wilson)
#	- FOG 1.0 (AGN)
#	- GRID 1.0 (Jim Patrick)
#	- HEIGHT 1.0 (Robin Hill)
#	- HELIX 1.3 (Peter Brown)
#	- ALL INSTANCES 1.0 (Rick Wilson)                                  (previously Instancescomponents.rb) 
#	- MAKE FACES 1.0 (Todd Burch)
#	- NUMBERED GRID 1.5 (Jim Patrick)
#	- ROTIX 1.2 (TBD)
#	- SHORTCUTS 1.0 (Steven)
#	- SPINNER 1.0 (@Last)                                              (previously animation.rb)
#	- SPIRAL STAIRS 1.0 (Rick Wilson)
#	- STAIRMAKER 0.5 (Christophe Hbert)
#	- STITCHER 1.1 (Rick Wilson)
#	- UTILITIES (@Last)
#	- WELD 1.0 (Rick Wilson)
#	- WINDOWIZER 2.1 (Rick Wilson)
#	
#
#
#
#
 
 
 
####################################################################################################  ARCHI MENU


# TOPO.RB  (Topography Script - Terrain Maker)  WORKING
# Version: 1.8  by Carlos Fale

      if( not file_loaded?("Scripts/TOPO.rb") )
        load "Scripts/TOPO.rb"
      _archi_plugins_menu.add_item("DTFile from Contour") {create_dtfile}
      _archi_plugins_menu.add_item("3DTopo from GRFile") {create_3dtopo_1}
      _archi_plugins_menu.add_item("3DTopo from Data File") {create_3dtopo_2}
      _archi_plugins_menu.add_item("3DTopo from Contour") {create_3dtopo_3}      
     
      file_loaded("Scripts/TOPO.rb")
      end      

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> 


# DELCO.RB  (Delete coplanar edges of a selection)  WORKING     - Runs from Context Menu
# Version: 1.5  by Carlos Fale

      if( not file_loaded?("Scripts/DELCO.rb") )
        load "Scripts/DELCO.rb"
       file_loaded("Scripts/DELCO.rb")
      end      

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         
    _archi_plugins_menu.add_separator     
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>       

      
# STAIR.RB  (Create parametric staircase)  WORKING
# Version: 1.0  by Tim

      if( not file_loaded?("Scripts/STAIR.rb") )
        load "Scripts/STAIR.rb"
      _archi_plugins_menu.add_item("Create Stair") { create_stair }
      file_loaded("Scripts/STAIR.rb")
      end      

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         

      
# STAIR_MAKER.RB  (Creates simple straight staircases)  WORKING
# Version: 0.5  by Christophe Hbert

      if( not file_loaded?("Scripts/STAIR_MAKER.rb") )
        load "Scripts/STAIR_MAKER.rb"
      _archi_plugins_menu.add_item("Stairs Concrete") { archetypesElements_straightConcreteStair }
      _archi_plugins_menu.add_item("Stairs Steel") { archetypesElements_straightSteelStair }
      _archi_plugins_menu.add_item("Stairs Wood") { archetypesElements_straightWoodStair }            
      file_loaded("Scripts/STAIR_MAKER.rb")
      end
      
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>       

      
# SPIRAL_STAIRS.RB  (Select 2 curves - stairs will be created between them)  WORKING
# Version: 1.0  by Rick Wilson

      if( not file_loaded?("Scripts/SPIRAL_STAIRS.rb") )
        load "Scripts/SPIRAL_STAIRS.rb"
      _archi_plugins_menu.add_item("Spiral Stairs") { spiral_stair }
      file_loaded("Scripts/SPIRAL_STAIRS.rb")
      end      

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         
    _archi_plugins_menu.add_separator     
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>       

  
# CABINET.RB  (Creates a cabinet)  WORKING
# Version: 1.0  by Todd Burch

      if( not file_loaded?("Scripts/CABINET.rb") )
        load "Scripts/CABINET.rb"
      _archi_plugins_menu.add_item("Cabinet") { create_cabinet }
      file_loaded("Scripts/CABINET.rb")
      end
      
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>       

      
# KITCHEN.RB  (Creates a simple kitchen top)  WORKING
# Version: 1.0  by Tim

      if( not file_loaded?("Scripts/KITCHEN.rb") )
        load "Scripts/KITCHEN.rb"
      _archi_plugins_menu.add_item("Create Top") { create_T_kitchen }
      file_loaded("Scripts/KITCHEN.rb")
      end        
      
      
      
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         
    _archi_plugins_menu.add_separator     
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> 


# CIRCLE_SLOPES.RB  (Create Circle Slopes )  WORKING
# Version: 1.0  by ODM

      if( not file_loaded?("Scripts/CIRCLE_SLOPES.rb") )
        load "Scripts/CIRCLE_SLOPES.rb"
      _archi_plugins_menu.add_item("Circle Slopes") { odm_aitop }
      file_loaded("Scripts/CIRCLE_SLOPES.rb")
      end

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> 

      
# DOME.RB  (Create Dome from circle)  WORKING
# Version: 1.0  by Frank Wiesner 

      if( not file_loaded?("Scripts/DOME.rb") )
        load "Scripts/DOME.rb"
        domeTool = Dome.new
      _archi_plugins_menu.add_item("Create Dome") { domeTool.dome_construct }
      file_loaded("Scripts/DOME.rb")
      end
      
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         


# CONE11.RB (Creates a cone)  WORKING
# Version: 1.1  by David R German

      if( not file_loaded?("Scripts/CONE11.rb") )
        load "Scripts/CONE11.rb"
      _archi_plugins_menu.add_item("Cone") { create_cone }
      file_loaded("Scripts/CONE11.rb")
      end
            
      
      
 
 
####################################################################################################  EDIT MENU 
      

# DESEL.RB (select only edges/faces and add/remove faces from a selection)  WORKING
# Version: 1.0  by TBD

        if( not file_loaded?("Scripts/DESEL.rb") )
        load "Scripts/DESEL.rb"
   

   _edit_plugins_menu.add_item("Deselect edges") { desel_func Sketchup::Edge}
   _edit_plugins_menu.add_item("Deselect faces") { desel_func Sketchup::Face}
   _edit_plugins_menu.add_item("Add faces") { add_faces }
   _edit_plugins_menu.add_item("Remove faces") { remove_faces }
   _edit_plugins_menu.add_separator

        file_loaded("Scripts/DESEL.rb")
      end
      
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>      
      

# BOMB.RB (Explode Items)  WORKING
# Version: 1.0  by Rick Wilson

        if( not file_loaded?("Scripts/BOMB.rb") )
        load "Scripts/BOMB.rb"
        _edit_plugins_menu.add_item("Explode Items") { bomb_groups }
        file_loaded("Scripts/BOMB.rb")
      end
 
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  
    _edit_plugins_menu.add_separator
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>    
 
 
# TRIM_EXTEND.RB  (Extend edges to the nearest intersected edge)  - WORKING
# Version: 1.0  by Rick Wilson

      if( not file_loaded?("Scripts/TRIM_EXTEND.rb") )
        load "Scripts/TRIM_EXTEND.rb"
      # Runs from Context Menu
      file_loaded("Scripts/TRIM_EXTEND.rb")
      end 
 
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  
      
      
# MAKE_FACES11.RB  (Creates a face where lines close)  WORKING
# Version: 1.0  by Todd Burch

      if( not file_loaded?("Scripts/MAKE_FACES11.rb") )
        load "Scripts/MAKE_FACES11.rb"
      _edit_plugins_menu.add_item("Make Faces") { makeFaces11 }
      file_loaded("Scripts/MAKE_FACES11.rb")
      end   
      
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>          
       
       
# CLEANUP_PUSHPULL.RB  (Creates a face where lines close)  WORKING
# Version: 1.0  by Carlo

      if( not file_loaded?("Scripts/CLEANUP_PUSHPULL.rb") )
        load "Scripts/CLEANUP_PUSHPULL.rb"
      _edit_plugins_menu.add_item("CleanUp PushPull") { erase_coplanar_edges }
      file_loaded("Scripts/MCLEANUP_PUSHPULL.rb")
      end         
      
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         
    
      
# STITCHER.RB  (Joins Lines, I think)  WORKING
# Version: 1.1  by Rick Wilson

      if( not file_loaded?("Scripts/STITCHER.rb") )
        load "Scripts/STITCHER.rb"
      _edit_plugins_menu.add_item("Stitcher") { stitch_faces }
      file_loaded("Scripts/STITCHER.rb")
      end      
      
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         
      
      
# CURVE_STITCHER.RB  (Joins curvy edges, I think)  WORKING
# Version: 2.1  by Rick Wilson

      if( not file_loaded?("Scripts/CURVE_STITCHER.rb") )
        load "Scripts/CURVE_STITCHER.rb"
      _edit_plugins_menu.add_item("Curve Stitcher") { stitch_curves }
      file_loaded("Scripts/CURVE_STITCHER.rb")
      end  
      

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  
    _edit_plugins_menu.add_separator
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>      

      
# REPAIR_BROKEN_LINES.RB  (Repairs broken co-linear lines)  WORKING
# Version: 1  by Carlo Roosen

      if( not file_loaded?("Scripts/REPAIR_BROKEN_LINES.rb") )
        load "Scripts/REPAIR_BROKEN_LINES.rb"
      _edit_plugins_menu.add_item("Repair Lines") { repair_broken_lines }
      file_loaded("Scripts/REPAIR_BROKEN_LINES.rb")
      end  
 
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


# WELD.RB (Select 2 faces - edges & faces will be created between them)  WORKING
# Version: 1.0  by Rick Wilson

        if( not file_loaded?("Scripts/WELD.rb") )
        load "Scripts/WELD.rb"
        _edit_plugins_menu.add_item("Weld Objects") { join_edges }
        file_loaded("Scripts/WELD.rb")
      end
 


###################################################################################################   MODIFY MENU 


# SCREW_21.RB  (Screw a set of edges around the z-axis, supports components, polar array maker )  WORKING
# Version: 2.1  by Frank Wiesner

      if( not file_loaded?("Scripts/SCREW_21.rb") )
        load "Scripts/SCREW_21.rb"
        screwTool = Screw.new
      _modify_plugins_menu.add_item("Array") { screwTool.screw_selection }
      file_loaded("Scripts/SCREW_21.rb")
      end  

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   
      _modify_plugins_menu.add_separator   
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   
    
      
# PUSH_PULL_Z_SET.RB  (Extrudes a selection of faces along the Z axis, not the face normal)  WORKING
# Version: 1  by Didier Bur

      if( not file_loaded?("Scripts/PUSH_PULL_Z_SET.rb") )
        load "Scripts/PUSH_PULL_Z_SET.rb"
      _modify_plugins_menu.add_item("PushPull Z") { push_pull_z_set }
      file_loaded("Scripts/PUSH_PULL_Z_SET.rb")
      end  
 
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  
    
      
# PUSH_PULL_VECTOR.RB  (Extrudes a selection of faces along the selected vector)  WORKING
# Version: 1  by Didier Bur

      if( not file_loaded?("Scripts/PUSH_PULL_VECTOR.rb") )
        load "Scripts/PUSH_PULL_VECTOR.rb"
      _modify_plugins_menu.add_item("PushPull Vector") { push_pull_vector }
      file_loaded("Scripts/PUSH_PULL_VECTOR.rb")
      end  
 
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   
      _modify_plugins_menu.add_separator   
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   


# MIDLINE2WALL.RB (Creates a wall with selected line, width and height, selected line is the axis of wall) (WORKING)
# Version: 1  by Didier Bur

      if( not file_loaded?("Scripts/MIDLINE2WALL.rb") )
        load "Scripts/MIDLINE2WALL.rb"
      _modify_plugins_menu.add_item("Mid-line to Wall") { midline_to_wall }
      file_loaded("Scripts/MIDLINE2WALL.rb")
      end  

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   


# LINES2WALL.RB (Creates walls with selected lines, arcs, circles, freehand curves, width and height supported) (WORKING)
# Version: 1  by Didier Bur

      if( not file_loaded?("Scripts/LINES2WALL.rb") )
        load "Scripts/LINES2WALL.rb"
      _modify_plugins_menu.add_item("Lines to Wall") { line_to_wall }
      file_loaded("Scripts/LINES2WALL.rb")
      end  

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   
      _modify_plugins_menu.add_separator   
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   


# PROJECT_FACES_PLANE.RB  (Project a set of faces perpendicular to the selected (double-clicked) face.)  WORKING
# Version: 1  by Didier Bur

      if( not file_loaded?("Scripts/PROJECT_FACES_PLANE.rb") )
        load "Scripts/PROJECT_FACES_PLANE.rb"
      _modify_plugins_menu.add_item("Project Faces") { project_faces_plane }
      file_loaded("Scripts/PROJECT_FACES_PLANE.rb")
      end  

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


# PROJECT_LINE_PLANE.RB  (Projects the selected line perpendicular to the selected face, can create a new face too.)  WORKING
# Version: 1  by Didier Bur

      if( not file_loaded?("Scripts/PROJECT_LINE_PLANE.rb") )
        load "Scripts/PROJECT_LINE_PLANE.rb"
      _modify_plugins_menu.add_item("Project Line to Plane") { project_lines_plane }
      file_loaded("Scripts/PROJECT_LINE_PLANE.rb")
      end  

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

# PROJECT_LINE_PLANES.RB  (Projects the selected line perpendicular to the selected set of faces, can create new faces too.)  WORKING
# Version: 1  by Didier Bur

      if( not file_loaded?("Scripts/PROJECT_LINE_PLANES.rb") )
        load "Scripts/PROJECT_LINE_PLANES.rb"
      _modify_plugins_menu.add_item("Project Line to Planes") { project_line_planes }
      file_loaded("Scripts/PROJECT_LINE_PLANES.rb")
      end  

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


# PROJECT_LINES_PLANE.RB  (Projects the selected set of lines perpendicular to the selected face, can create new faces too.)  WORKING
# Version: 1  by Didier Bur

      if( not file_loaded?("Scripts/PROJECT_LINES_PLANE.rb") )
        load "Scripts/PROJECT_LINES_PLANE.rb"
      _modify_plugins_menu.add_item("Project Lines to Plane") { project_lines_plane }
      file_loaded("Scripts/PROJECT_LINES_PLANE.rb")
      end  

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


# PROJECT_POINT_LINE.RB  (Projects the selected construction point perpendicular to the selected line.)  WORKING
# Version: 1  by Didier Bur

      if( not file_loaded?("Scripts/PROJECT_POINT_LINE.rb") )
        load "Scripts/PROJECT_POINT_LINE.rb"
      _modify_plugins_menu.add_item("Project Point to Line") { project_point_line }
      file_loaded("Scripts/PROJECT_POINT_LINE.rb")
      end  

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


# PROJECT_POINT_PLANE.RB  (Projects the selected construction point perpendicular to the selected face.)  WORKING
# Version: 1  by Didier Bur

      if( not file_loaded?("Scripts/PROJECT_POINT_PLANE.rb") )
        load "Scripts/PROJECT_POINT_PLANE.rb"
      _modify_plugins_menu.add_item("Project Point to Face") { project_point_plane }
      file_loaded("Scripts/PROJECT_POINT_PLANE.rb")
      end  

          
      
###################################################################################################   VIEW MENU 
      
      
# FOG.RB  (Restores fog features in SU4)  WORKING
# Version: 1.0  by AGN

      if( not file_loaded?("Scripts/FOG.rb") )
        load "Scripts/FOG.rb"
        _view_plugins_menu.add_item("Fog Control") { Sketchup.send_action 21406}
        file_loaded("Scripts/FOG.rb")
      end
      
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   
      _view_plugins_menu.add_separator   
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         
      
      
# VOLUME.RB  (Computes volume of selected parallelepipedic group)  WORKING   Runs from Context Menu
# Version: 1.0  by TBD

      if( not file_loaded?("Scripts/VOLUME.rb") )
        load "Scripts/VOLUME.rb"
        _view_plugins_menu.add_item("Compute Volume") { volume }
        file_loaded("Scripts/VOLUME.rb")
      end
      

     
################################################################################################### CAMERA MENU
     
     
# CAMERA_PARAMETERS.RB  (Camera control script)  WORKING
# Version: 1.0  by Envision 3D

      if( not file_loaded?("Scripts/CAMERA_PARAMETERS.rb") )
        load "Scripts/CAMERA_PARAMETERS.rb"
        _camera_plugins_menu.add_item("Camera / VP / Target") { camera_vp_targ }
      # camera vp targ item
        _camera_plugins_menu.add_item("Camera / Azimuth / Elevation") { camera_vp_az_el }
        file_loaded("Scripts/CAMERA_PARAMETERS.rb")
      end

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         
      _camera_plugins_menu.add_separator   
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>        
     
     
# SPINNER.RB  (Spins the model 360 degrees)  WORKING
# Version: 1.0  by @Last

      if( not file_loaded?("Scripts/SPINNER.rb") )
        load "Scripts/SPINNER.rb"
        _camera_plugins_menu.add_item("Spin view") { spinview }
       # stop animation item
        _camera_plugins_menu.add_item("Stop spinning") { Sketchup.active_model.active_view.animation = nil }
        file_loaded("Scripts/SPINNER.rb")
      end
      
      
      
####################################################################################################  DRAW MENU
      

# BEZIER.RB  (Creates bezier curves)  WORKING
# Version: 1.0  by @Last

      if( not file_loaded?("Scripts/BEZIER.rb") )
        load "Scripts/BEZIER.rb"
      _draw_plugins_menu.add_item("Bezier"){ Bezier.tool }
      file_loaded("Scripts/BEZIER.rb")
      end  

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   
   _draw_plugins_menu.add_separator
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   
      
      
# GRID.RB (Creates a custom grid from 0,0,0)  WORKING
# Version: 1.0  by Jim Patrick

      if( not file_loaded?("Scripts/GRID.rb") )
        load "Scripts/GRID.rb"
        _draw_plugins_menu.add_item("Grid") { create_grid }
        file_loaded("Scripts/GRID.rb")
      end
 
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   


# GRID_CUBE.RB (Creates a 3D custom grid from 0,0,0)  WORKING
# Version: 1.0  by Jim Patrick/Didier Bur

      if( not file_loaded?("Scripts/GRID_CUBE.rb") )
        load "Scripts/GRID_CUBE.rb"
        _draw_plugins_menu.add_item("Grid Cube") { create_3d_colored_grid }
        file_loaded("Scripts/GRID_CUBE.rb")
      end 
 
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         

 
# 3D_GRID.RB (Creates a 3D custom grid from 0,0,0)  WORKING
# Version: 1.0  by Jim Patrick/Didier Bur

      if( not file_loaded?("Scripts/3D_GRID.rb") )
        load "Scripts/3D_GRID.rb"
        _draw_plugins_menu.add_item("3D Grid") { create_3d_grid }
        file_loaded("Scripts/3D_GRID.rb")
      end 
 
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         
      
     
# NUMBERED_GRID.RB  (Creates a custom grid from 0,0,0 with number references)  WORKING
# Version: 1.5  by Jim Patrick

        if( not file_loaded?("Scripts/NUMBERED_GRID.rb") )
        load "Scripts/NUMBERED_GRID.rb"
        _draw_plugins_menu.add_item("Grid Numbered") { create_NumGrid }
        file_loaded("Scripts/NUMBERED_GRID.rb")
      end

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         
   _draw_plugins_menu.add_separator
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   
      
      
# BOX.RB (Creates a cube at 0,0,0)  WORKING
# Version: 1.0  by @Last

      if( not file_loaded?("Scripts/BOX.rb") )
        load "Scripts/BOX.rb"
      _draw_plugins_menu.add_item("Box at 0,0,0") { create_box }
      file_loaded("Scripts/BOX.rb")
      end
      
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         
      
      
# BOX_POS.RB  (Creates a cube at specified X Y Z)  WORKING
# Version: 1.0  by @Last

      if( not file_loaded?("Scripts/BOX_POS.rb") )
        load "Scripts/BOX_POS.rb"
      _draw_plugins_menu.add_item("Box at X,Y,Z") { create_box_pos }
      file_loaded("Scripts/BOX_POS.rb")
      end
      
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         

      
# BOXES_ARRAY.RB (Creates a cube at 0,0,0)  WORKING
# Version: 1.0  by @Last

      if( not file_loaded?("Scripts/BOXES_ARRAY.rb") )
        load "Scripts/BOXES_ARRAY.rb"
      _draw_plugins_menu.add_item("Boxes Array") { create_boxes }
      file_loaded("Scripts/BOXES_ARRAY.rb")
      end
            
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         
      
# BOXES_RANDOM.RB (Creates a cube at random position)  WORKING
# Version: 1.0  by @Last

      if( not file_loaded?("Scripts/BOXES_RANDOM.rb") )
        load "Scripts/BOXES_RANDOM.rb"
      _draw_plugins_menu.add_item("Random Boxes") { create_rand_boxes }
      file_loaded("Scripts/BOXES_RANDOM.rb")
      end
            
      
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         
    _draw_plugins_menu.add_separator     
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         
      
      
# HELIX.RB  (Creates a helix)  WORKING
# Version: 1.3  by Peter Brown

      if( not file_loaded?("Scripts/HELIX.rb") )
        load "Scripts/HELIX.rb"
      _draw_plugins_menu.add_item("Helix") { drawhelix }
      file_loaded("Scripts/HELIX.rb")
      end
      
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>    
    _draw_plugins_menu.add_separator    
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>        
      
      
# WINDOWIZER.RB  (Creates a set of windows on faces)   Runs from context menu
# Version: 2.1  by Rick Wilson

      if( not file_loaded?("Scripts/WINDOWIZER.rb") )
        load "Scripts/WINDOWIZER.rb"
      # Runs from Context Menu
      file_loaded("Scripts/WINDOWIZER.rb")
      end




###################################################################################################  TEXT MENU

      
# PICK_IMPORT_TEXT.RB  (Imports and places an ascii text file as a block or line by line at the picked point, layer selectable)  WORKING
# Version: 1.0  by Didier Bur

      if( not file_loaded?("Scripts/PICK_IMPORT_TEXT.rb") )
        load "Scripts/PICK_IMPORT_TEXT.rb"
         _text_plugins_menu.add_item("Import Text File") { Sketchup.active_model.select_tool Input_point.new }       
        file_loaded("Scripts/PICK_IMPORT_TEXT.rb")
      end
      
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         
    _text_plugins_menu.add_separator     
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>       


# HEIGHT.RB  (Adds a text specifying the height of an object)  WORKING
# Version: 1.0  by Robin Hill

      if( not file_loaded?("Scripts/HEIGHT.rb") )
        load "Scripts/HEIGHT.rb"
      _text_plugins_menu.add_item("Height Text") { Sketchup.active_model.select_tool HeightTool.new }
      file_loaded("Scripts/HEIGHT.rb")
    end
	    
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   


# NUMB.RB  (Inserts text with incremental values, right-click to change increment)  WORKING
# Version: 1.0  by TBD

      if( not file_loaded?("Scripts/NUMB.rb") )
        load "Scripts/NUMB.rb"
      _text_plugins_menu.add_item("Incremental Numbers") { Sketchup.active_model.select_tool Numb.new }
      file_loaded("Scripts/NUMB.rb")
    end
    
    
      
###################################################################################################  TOOLS MENU
           

# ROTIX.RB  (Allows the specified or random rotating of objects)  WORKING
# Version: 1.2  by TBD

      if( not file_loaded?("Scripts/ROTIX.rb") )
        load "Scripts/ROTIX.rb"
        _tools_plugins_menu.add_item("Rotix Step, 90, random") { Sketchup.active_model.select_tool Rotix.new }
        file_loaded("Scripts/ROTIX.rb")
      end 

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>      
 
 
# ALL_INSTANCES.RB  (Select all instances of a selected component)  WORKING
# Version: 2.1  by Rick Wilson

      if( not file_loaded?("Scripts/ALL_INSTANCES.rb") )
        load "Scripts/ALL_INSTANCES.rb"
      # Runs from Context Menu
      file_loaded("Scripts/ALL_INSTANCES.rb")
      end  
 
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>        

      
# DROP.RB  (drop group/component on selected level (change in Y))  WORKING
# Version: 1.5  by TBD

      if( not file_loaded?("Scripts/DROP.rb") )
        load "Scripts/DROP.rb"
      # Runs from Context Menu
      file_loaded("Scripts/DROP.rb")
      end 

  end       

# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>         
      _tools_plugins_menu.add_separator     
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   
      
      
# ATTRIBUTES.RB  (Assign estimate to material item)  WORKING
# Version: 1.0  by @Last

      if( not file_loaded?("Scripts/ATTRIBUTES.rb") )
        load "Scripts/ATTRIBUTES.rb"
      _tools_plugins_menu.add_item("Assign estimate to material") { assign_estimate_to_material }
      # attach cost estimate item
      _tools_plugins_menu.add_item("Attach cost to faces") { attach_cost_estimate }
      # compute estimate item
      _tools_plugins_menu.add_item("Compute estimate") { compute_cost_estimate }
      file_loaded("Scripts/ATTRIBUTES.rb")
      end
      
      
      
#################################################################################################  WINDOWS MENU 

       
# List shortcuts item (Accelerators)  (doesn't need any loading)  WORKING
# Version: 1.0

      _windows_plugins_menu.add_item("List Shortcuts") { Sketchup.send_action 21477}

    $_menu_loaded = true
  end


# file_loaded("menus.rb")
